let nbProjectCards = 3;

function setupPage2(){
    let slideFunction = slideContainer();
    document.getElementById("project-button-left").addEventListener("click", () => slideFunction("left") );
    document.getElementById("project-button-right").addEventListener("click", () => slideFunction("right"));

    for (let i = 0; i < nbProjectCards; i++){

        for (let p = 0; p<i; p++) {
            console.log("i " + i + " p " + p)
            let cardElem = document.getElementById("project-card-" + i);
            console.log(cardElem.style.translate)
            let val = window.innerWidth  + parseInt(cardElem.style.translate === "" ? "0" : cardElem.style.translate) + "px"
            console.log("sliding to:" +  val)

            cardElem.style.translate = val
            cardElem.style.transition = "1s"
        }

    }
}


function slideContainer(){

    let currentProject: number = 0;
    const projectWidth = window.innerWidth;
    function slide(side: string){
        let factor = side === "left" ? 1 : -1;
        const nextCard: number = (currentProject - factor + nbProjectCards) % nbProjectCards; // Small hack to ensure that the value is always positive

        console.log(`Sliding: ${side}. Current Card: ${currentProject}. Next Card: ${nextCard}`)

        const CurrentCardElem = document.getElementById("project-card-" + currentProject);
        const NextCardElm = document.getElementById("project-card-" + nextCard);

        setProjectCardToPosition(NextCardElm, factor);
        setTimeout(() => {
            moveProjectCardToPosition(CurrentCardElem, factor);
            moveProjectCardToPosition(NextCardElm, 0);
        }, 1)

        currentProject = nextCard;
    }

    function setProjectCardToPosition(elm: HTMLElement, direction: number){
        elm.style.visibility = "hidden"
        elm.style.translate = -1 * direction * projectWidth + "px";
        elm.style.transition = "0s"
    }
    function moveProjectCardToPosition(elm: HTMLElement, direction: number){
        elm.style.translate = direction * projectWidth + "px";
        elm.style.transition = "1s"
        elm.style.visibility = "visible"
    }
    return slide;
}


addEventListener("load", setupPage2)